package com.gic.message.utils;

import com.gic.binlog.base.entity.GicField;
import com.gic.binlog.base.entity.GicRecord;
import com.gic.binlog.base.entity.enums.GicRecordType;
import org.apache.kafka.clients.consumer.ConsumerRecord;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class ListToMapUtil {
    public static Map<String, GicField> listToMap(ConsumerRecord<String, GicRecord> consumerRecord){
        GicRecord value = consumerRecord.value();
        List<GicField> list = value.getFieldList();
        Map<String, GicField> result = new HashMap<>();
        if(value.getRecordType().value() == GicRecordType.INSERT.value() || value.getRecordType().value() == GicRecordType.DELETE.value()){
            for(int i=0; i< list.size(); i++){
                GicField gicField = list.get(i);
                result.put(gicField.getName(), gicField);
            }
        }
        if(value.getRecordType().value() == GicRecordType.UPDATE.value()){
            for(int i=0; i<list.size();){
                GicField oldField = list.get(i);
                GicField newFiled = list.get(i+1);
                result.put("old_"+oldField.getName(), oldField);
                result.put("new_"+newFiled.getName(), newFiled);
                i = i+2;
            }
        }
        return result;
    }
}
